﻿

package {
	import flash.printing.PrintJob;
	import flash.printing.PrintJobOptions;
	import flash.display.*;
	import flash.events.*;

	public class printEx extends Sprite {
		public var myPrintJob:PrintJob = new PrintJob();
		private var options:PrintJobOptions = new PrintJobOptions();
		private var mySprite:Sprite = new Sprite();
		private var amount:int;
		private var StageAccess:MovieClip;

		public function printEx(ref) {
			StageAccess = ref;
			amount = StageAccess.numChildren;
			printIt();
		}
		private function printIt():void {
			StageAccess.addChild(mySprite);
			options.printAsBitmap = false;

			if (myPrintJob.start()) {
				try {
					createTempSprite();
				} catch (error:Error) {
				}
				myPrintJob.send();
				clearTempSprite();
				
			} else {
				trace("Print job canceled");
				StageAccess.removeChild(mySprite);
			}

		}
		private function createTempSprite():void {
			for (var i:int=0; i < amount; i++) {
				mySprite.addChild(StageAccess.getChildAt(0));
			}
			mySprite.scaleX = .8
			mySprite.scaleY = .8
			myPrintJob.addPage(mySprite, null, options);
		}
		private function clearTempSprite():void {
			for (var i:int=0; i < amount; i++) {
				StageAccess.addChild(mySprite.getChildAt(0));
			}
			StageAccess.removeChild(mySprite);
			trace("Print job cleared <<<<")
		}
	}
}